dot/gpg.conf.m4, dot/gpg-agent.conf, Makefile: Adopt GnuPG configuration.
[profile] / bin / mdw-sbuild
CommitLineData
b94830d9
MW
1#! /bin/sh -e
2###
3### Build a Debian package on an sbuild server.
4###
5### (c) 2016 Mark Wooding
6###
7
8###----- Licensing notice ---------------------------------------------------
9###
10### This program is free software; you can redistribute it and/or modify
11### it under the terms of the GNU General Public License as published by
12### the Free Software Foundation; either version 2 of the License, or
13### (at your option) any later version.
14###
15### This program is distributed in the hope that it will be useful,
16### but WITHOUT ANY WARRANTY; without even the implied warranty of
17### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18### GNU General Public License for more details.
19###
20### You should have received a copy of the GNU General Public License
21### along with this program; if not, write to the Free Software Foundation,
22### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
23
24###--------------------------------------------------------------------------
25### Some utilities.
26
27prog=${0##*/}
28
29fail () { echo >&2 "$prog: $*"; exit 1; }
ff55a023 30usage () { echo "usage: $prog [-ainT] [-k KEYID] [-p DIR] [-t TARGET] [-A DBPARGS] HOST"; }
b94830d9
MW
31fail_usage () { usage >&2; exit 1; }
32
33###--------------------------------------------------------------------------
34### Parse options.
35
abfec703 36bogusp=nil noactp=nil signp=nil
5e9e7146 37unset buildopts pkgs dbpargs
ff55a023 38while getopts "haik:np:t:A:T" opt; do
b94830d9
MW
39 case $opt in
40 h)
41 usage
42 cat <<EOF
43
44Options:
45 -h Show this help text.
46 -a Build only architecture-dependent packages.
47 -i Build only architecture-neutral packages.
48 -k KEYID Sign the result using KEYID.
49 -n Don't actually do the build.
6cf97414 50 -p DIR Upload additional packages from DIR.
b94830d9 51 -t TARGET Build in TARGET build environment.
5e9e7146 52 -A ARGS Pass ARGS to \`dpkg-buildpackage'.
ff55a023 53 -T Don't run the tests.
b94830d9
MW
54EOF
55 exit 0
56 ;;
57 a) buildopts="${buildopts+$buildopts }-a" ;;
58 i) buildopts="${buildopts+$buildopts }-i" ;;
8c67a535 59 k) signp=t keyid=$OPTARG ;;
b94830d9 60 n) buildopts="${buildopts+$buildopts }-n" noactp=t ;;
6cf97414 61 p) pkgs=$OPTARG ;;
b94830d9 62 t) buildopts="${buildopts+$buildopts }-t$OPTARG" ;;
5e9e7146
MW
63 A)
64 buildopts="${buildopts+$buildopts }-A$OPTARG"
65 dbpargs="${dbpargs+$dbpargs }$OPTARG"
66 ;;
ff55a023 67 T) buildopts="${buildopts+$buildopts }-T" ;;
b94830d9
MW
68 *) bogusp=t ;;
69 esac
70done
71shift $(( $OPTIND - 1 ))
72case $# in
73 1) host=$1 ;;
74 *) bogusp=t ;;
75esac
76case $bogusp in t) fail_usage ;; esac
8c67a535 77case $noactp in t) signp=nil ;; esac
6cf97414 78case ${pkgs-/hack} in /*) ;; *) pkgs=$(pwd)/$pkgs ;; esac
b94830d9
MW
79
80###--------------------------------------------------------------------------
81### Main program.
82
83## Figure out the package name and version number.
84unset pkg ver
85while read tag value; do
86 case $tag in
87 Source:) pkg=$value ;;
88 Version:) ver=$value ;;
89 esac
90done <<EOF
91$(dpkg-parsechangelog)
92EOF
93case ${pkg+t} in t) ;; *) fail "can't figure out the package name" ;; esac
94case ${ver+t} in t) ;; *) fail "can't figure out the package version" ;; esac
95
8c67a535
MW
96## Build a Debian source package. Don't sign anything yet. That will happen
97## at the end, all in one go.
5e9e7146 98dpkg-buildpackage -S -uc -us -d -i $dbpargs
8c67a535 99cd ..
b94830d9
MW
100dsc=${pkg}_${ver}.dsc
101[ -f "$dsc" ] || fail "where is my \`.dsc' file?"
102
97720cf5
MW
103## Actually do the build. Get a build directory assigned by the server,
104## upload the sources, run the build, and collect the results.
b94830d9
MW
105builddir=$(ssh "$host" mdw-sbuild-server dir "$pkg/$ver")
106dcmd rsync -a "$dsc" "$host:$builddir/"
6cf97414 107case ${pkgs+t} in t) rsync -a "$pkgs/" "$host:$builddir/pkgs/" ;; esac
b94830d9
MW
108set +e; ssh "$host" mdw-sbuild-server $buildopts build "$builddir"
109rc=$?; set -e
110rsync -a "$host:$builddir/" ./
111case $rc in 0) ;; *) exit $rc ;; esac
97720cf5 112
bcd2df0a
MW
113## Merge the change files together, and maybe sign the result.
114chchch=${pkg}_${ver}_source.changes
115for i in "${pkg}_${ver}"_*.changes; do
116 case " $chchch " in *" $i "*) ;; *) chchch="$chchch $i" ;; esac
117done
118mergechanges -f $chchch
119rm $chchch
abfec703 120case $signp in
bcd2df0a 121 t) debsign -k"$keyid" "${pkg}_${ver}_multi.changes" ;;
b94830d9 122esac
5e9e7146
MW
123
124###----- That's all, folks --------------------------------------------------